#include "Camera.h"
#include "Player.h"
#include "LevelManager.h"

fix32 camX = FIX32(0);
fix32 camY = FIX32(0);

void UpdateCamera()
{
    fix32 newCamX = FIX32(0);
    fix32 newCamY = FIX32(0);

    // get sprite position on screen
    fix32 playerScreenX = player->x - camX;
    fix32 playerScreenY = player->y - camY;

    if (playerScreenX > FIX32(128))
        newCamX = player->x - FIX32(128);
    else if (playerScreenX < FIX32(120))
        newCamX = player->x - FIX32(120);
    else
        newCamX = camX;

    // clip camera position
    if (newCamX < FIX32(0))
        newCamX = FIX32(0);

    if (newCamY < FIX32(0))
        newCamY = FIX32(0);
    else if (newCamY > FIX32(100))
        newCamY = FIX32(100);

    if ((newCamX != camX) || (newCamY != camY))
    {
        camX = newCamX;
        camY = newCamY;

        u16 h_scrolled_tiles = fix32ToInt(camX) >> 3;
        u16 update_column = h_scrolled_tiles & (planWidth - 1);

        VDP_setHorizontalScroll(PLAN_A, fix32ToInt(-camX));
        VDP_setHorizontalScroll(PLAN_B, fix32ToInt(-camX >> 3));

        if (player->goingRight)
        {
            VDP_setMapEx(PLAN_A, currentMap, TILE_ATTR_FULL(PAL0, FALSE, FALSE, FALSE, TILE_USERINDEX), update_column - 1, 0, planWidth + h_scrolled_tiles - 1, 0, 1, planHeight);
        }
        else
        {
            VDP_setMapEx(PLAN_A, currentMap, TILE_ATTR_FULL(PAL0, FALSE, FALSE, FALSE, TILE_USERINDEX), update_column, 0, h_scrolled_tiles, 0, 1, planHeight);
        }
    }
}