#include "JoypadManager.h"

#define TAP_HOLD_THRESHOLD 8

u16 joystate;
u16 oldjoystate;
JoystickStateStruct joystickState;

void JoypadManager_Init()
{
    oldjoystate = 0;
}

void JoypadManager_ResetJoypad()
{
    joystickState.startPressed = 0;
    joystickState.aPressed = 0;
    joystickState.bPressed = 0;
    joystickState.cPressed = 0;
    joystickState.leftPressed = 0;
    joystickState.rightPressed = 0;
    joystickState.upPressed = 0;
    joystickState.downPressed = 0;
    joystickState.leftReleased = 0;
    joystickState.rightReleased = 0;
    joystickState.upReleased = 0;
    joystickState.downReleased = 0;
    joystickState.pressedLeftTimer = 0;
    joystickState.leftTapCount = 0;
    joystickState.leftTapStartTime = 0;
    joystickState.countSinceLastLeftTap = 0;
    joystickState.pressedRightTimer = 0;
    joystickState.rightTapCount = 0;
    joystickState.rightTapStartTime = 0;
    joystickState.countSinceLastRightTap = 0;
}

void JoypadManager_ResetTaps()
{
    joystickState.countSinceLastLeftTap = 0;
    joystickState.leftTapCount = 0;
    joystickState.countSinceLastRightTap = 0;
    joystickState.rightTapCount = 0;
}

void JoypadManager_UpdateJoypad()
{
    joystate = JOY_readJoypad(JOY_1);

    // the player let go of the right direction.
    if (!(joystate & BUTTON_RIGHT) && (oldjoystate & BUTTON_RIGHT))
    {
        if ((joystickState.pressedRightTimer > 0) &&
            joystickState.pressedRightTimer <= TAP_HOLD_THRESHOLD)
        {
            joystickState.rightTapCount++;
        }
    }

    /*
    if ((joystate & BUTTON_RIGHT) && !(oldjoystate & BUTTON_RIGHT))
    {
        Print("Time Since Last Tap");
        PrintNumber(joystickState.countSinceLastRightTap);
    }
    */
    // if holding right, count.
    if (joystate & BUTTON_RIGHT)
    {
        joystickState.pressedRightTimer++;
        joystickState.countSinceLastRightTap = 0;
    }
    else // not
    {
        // stop counting
        joystickState.pressedRightTimer = 0;
                
        // start counting the time since last tap
        joystickState.countSinceLastRightTap++;

        // if it's been too long since the last tap, reset the taps
        if (joystickState.countSinceLastRightTap > TAP_HOLD_THRESHOLD)
        {
            joystickState.countSinceLastRightTap = 0;
            joystickState.rightTapCount = 0;
        }
    }




    // the player let go of the Left direction.
    if (!(joystate & BUTTON_LEFT) && (oldjoystate & BUTTON_LEFT))
    {
        if ((joystickState.pressedLeftTimer > 0) &&
            joystickState.pressedLeftTimer <= TAP_HOLD_THRESHOLD)
        {
            joystickState.leftTapCount++;
        }
    }

    // if holding Left, count.
    if (joystate & BUTTON_LEFT)
    {
        joystickState.pressedLeftTimer++;
        joystickState.countSinceLastLeftTap = 0;
    }
    else // not
    {
        // stop counting
        joystickState.pressedLeftTimer = 0;
                
        // start counting the time since last tap
        joystickState.countSinceLastLeftTap++;

        // if it's been too long since the last tap, reset the taps
        if (joystickState.countSinceLastLeftTap > TAP_HOLD_THRESHOLD)
        {
            joystickState.countSinceLastLeftTap = 0;
            joystickState.leftTapCount = 0;
        }
    }

    joystickState.startPressed = (joystate & BUTTON_START) && ((oldjoystate & BUTTON_START) == 0);
    joystickState.aPressed = (joystate & BUTTON_A) && ((oldjoystate & BUTTON_A) == 0);
    joystickState.bPressed = (joystate & BUTTON_B) && ((oldjoystate & BUTTON_B) == 0);
    joystickState.cPressed = (joystate & BUTTON_C) && ((oldjoystate & BUTTON_C) == 0);

    joystickState.leftPressed = (joystate & BUTTON_LEFT) && ((oldjoystate & BUTTON_LEFT) == 0);
    joystickState.rightPressed = (joystate & BUTTON_RIGHT) && ((oldjoystate & BUTTON_RIGHT) == 0);

    joystickState.upPressed = (joystate & BUTTON_UP) && ((oldjoystate & BUTTON_UP) == 0);
    joystickState.downPressed = (joystate & BUTTON_DOWN) && ((oldjoystate & BUTTON_DOWN) == 0);

    joystickState.leftReleased = !(joystate & BUTTON_LEFT) && (oldjoystate & BUTTON_LEFT);
    joystickState.rightReleased = !(joystate & BUTTON_RIGHT) && (oldjoystate & BUTTON_RIGHT);

    oldjoystate = joystate;
}
