#ifndef JOYPAD_MANAGER_INCLUDE_H
#define JOYPAD_MANAGER_INCLUDE_H

#include <genesis.h>

typedef struct
{
    u16 startPressed;
    u16 aPressed;
    u16 bPressed;
    u16 cPressed;

    u16 leftPressed;
    u16 rightPressed;
    u16 upPressed;
    u16 downPressed;

    u16 leftReleased;
    u16 rightReleased;
    u16 upReleased;
    u16 downReleased;
    
    //  left dpad button
    u16 pressedLeftTimer;
    u16 leftTapCount;
    u16 leftTapStartTime;
    u16 countSinceLastLeftTap;

    // right dpad button
    u16 pressedRightTimer;
    u16 rightTapCount;
    u16 rightTapStartTime;
    u16 countSinceLastRightTap;

} JoystickStateStruct;

extern u16 joystate;
extern JoystickStateStruct joystickState;

void JoypadManager_Init();
void JoypadManager_ResetTaps();
void JoypadManager_ResetJoypad();
void JoypadManager_UpdateJoypad();

#endif
