#include <genesis.h>
#include "Camera.h"
#include "Constants.h"
#include "Utils.h"
#include "AllObjects.h"

typedef struct
{
    ObjectCreateFunctionType createObject;
    s16 tileX;
    s16 tileY;
    s16 width;
} SpawnStruct;
 
u8 currentSpawn = 0;
u8 spawnsSize = 0;

char buffer[256];

SpawnStruct const spawns[] =
{
    //{HellhoundCreate, 17, 7, 48},
    {HellhoundCreate, 29, 7, 48},
    {HellhoundCreate, 30, 7, 48},
    {HellhoundCreate, 31, 7, 48},
    //{HellhoundCreate, 32, 7, 48},
    //{HellhoundCreate, 40, 6, 48},

    //{0, HellhoundCreate, 46, 5, 48},
};

void ObjectSpawner_Init()
{
    spawnsSize = sizeof(spawns) / sizeof(spawns[0]);
    KLog_U1(buffer, spawnsSize);
}

void ObjectSpawner_Update()
{
    if (currentSpawn < spawnsSize)
    {
        SpawnStruct spawnStruct = spawns[currentSpawn];
        if (isVisible(fix32ToInt(camX), fix32ToInt(camX) + SCREEN_WIDTH, spawnStruct.tileX << 4))
        {
            spawnStruct.createObject(FIX32(spawnStruct.tileX << 4), FIX32(spawnStruct.tileY << 4));
            currentSpawn++;
        }
    }
}